#include "l7-connection.h"
#include "util.h"

l7_connection::l7_connection(unsigned int num_packets) : num_packets(num_packets)
{
    buf_length = num_packets * MAX_PACKET_LENGTH;
    buffer = new char[buf_length];
    new_packets = new char[num_packets * MAX_PACKET_LENGTH];
    new_packet_lengths = new unsigned int[num_packets];
    buffer[0] = '\0';
    cur_length = 0;
    mark = UNTOUCHED;
    packet_number = 0;
    thread_num = 0;
    read_index = 0;
    write_index = 0;
    flag = 0;
}

l7_connection::~l7_connection()
{
    if (buffer != NULL)
    {
        delete [] buffer;
        buffer = NULL;
    }
    
    if (new_packets != NULL)
    {
        delete [] new_packets;
        new_packets = NULL;
    }
    
    if (new_packet_lengths != NULL)
    {
        delete [] new_packet_lengths;
        new_packet_lengths = NULL;
    }
}

unsigned int l7_connection::get_mark()
{
    return mark;
}

unsigned int l7_connection::set_mark(unsigned int new_mark)
{
    unsigned int old_mark = mark;
    mark = new_mark;
    return old_mark;
}

const string &l7_connection::get_key()
{
    return key;
}

string l7_connection::set_key(const string &new_key)
{
    string old_key = key;
    key = new_key;
    return old_key;
}

char *l7_connection::get_buffer()
{
    return buffer;
}

/*
bool l7_connection::append_to_buffer(const char *data, unsigned int data_bytes)
{
    if (cur_length + data_bytes >= buf_length)
    {
        return false;
    }

    cur_length--;

    memcpy(buffer + cur_length, data, data_bytes);
    cur_length += data_bytes;

    buffer[cur_length] = '\0';
    
    packet_number++;

    return true;
}
*/

unsigned int l7_connection::get_buffer_cur_length()
{
    return cur_length;
}

unsigned int l7_connection::get_packet_number()
{
    return packet_number;
}

unsigned int l7_connection::get_thread_num()
{
    return thread_num;
}

void l7_connection::set_thread_num(unsigned int new_thread_num)
{
    thread_num = new_thread_num;
}

bool l7_connection::set_new_packet(const char *buf, unsigned int bytes)
{
    if (bytes > 1500)
    {
        // l7printf(0, "Error: new packet length > 1500!\n");
        return false;
    }
    
    if (write_index >= num_packets)
    {
        // l7printf(0, "Error: the number of packets is more than the maximum number!\n");
        return false;
    }

    memcpy(new_packets + write_index * MAX_PACKET_LENGTH, buf, bytes);
    new_packet_lengths[write_index] = bytes;
    write_index++;
    
//	packet_number++;
    return true;
}

void l7_connection::reassembly_new_packet()
{
    if (write_index < num_packets && read_index < write_index && cur_length + new_packet_lengths[read_index] < buf_length)
    {
        memcpy(buffer + cur_length, new_packets + read_index * MAX_PACKET_LENGTH,
               new_packet_lengths[read_index]);
        cur_length += new_packet_lengths[read_index];
        read_index++;

        buffer[cur_length+1] = '\0';
    
        packet_number++;
    }
}
