#ifndef L7_CONNECTION_H

#define L7_CONNECTION_H

#define UNTOUCHED    0 /* means never try to match */
#define NO_MATCH_YET 1 /* means tried and failed, but will try later */
#define NO_MATCH     2 /* means tried and failed, and never try again */

#define MAX_PACKET_LENGTH 1500 // Ehternet max packet length

#include <string>

using namespace std;
class l7_connection
{
private:

    unsigned int mark;
    string key;
    const unsigned int num_packets;
    unsigned int buf_length;
    unsigned int cur_length;
    char * buffer;
    unsigned int packet_number;
    unsigned int thread_num;
    char * new_packets;
    unsigned int * new_packet_lengths;
    unsigned int read_index;
    unsigned int write_index;

public:
    unsigned int ID; // for connection buffer statistics
    unsigned int flag;
    l7_connection(unsigned int num_packets);
    ~l7_connection();
    unsigned int get_mark();
    unsigned int set_mark(unsigned int new_mark);
    const string & get_key();
    string set_key(const string & new_key);
    char * get_buffer();
    // bool append_to_buffer(const char * data, unsigned int data_bytes);
    unsigned int get_buffer_cur_length();
    unsigned int get_packet_number();
    unsigned int get_thread_num();
    void set_thread_num(unsigned int new_thread_num);
    bool set_new_packet(const char *buf, unsigned int length);
    void reassembly_new_packet();
};

#endif
