#ifndef QUEUE_MT_H
#define QUEUE_MT_H

template <class QEntry>
class QMT
{
private:
    unsigned int nPushPos, nPopPos;
    unsigned int nPush, nPop;
    unsigned int nSize;

    QEntry *pBuffer;

public:
    QMT()
    {
        nPushPos = 0;
	    nPopPos = 0;
	    nPush = 0;
	    nPop = 0;
	    
        nSize = 0;
        pBuffer = NULL;
    }

    ~QMT()
    {
        if (pBuffer == NULL)
        {
            delete[] pBuffer;
        }
        pBuffer = NULL;
    }
    
    bool Init(unsigned int size)
    {
        nPushPos = 0;
	    nPopPos = 0;
	    nPush = 0;
	    nPop = 0;
	    
	    if (pBuffer != NULL)
	    {
	        delete[] pBuffer;
	    }
	    
        nSize = size;
        pBuffer = new QEntry[nSize];
        if (pBuffer == NULL)
        {
            return false;
        }
        
        return true;
    }

    bool Push(const QEntry & entry)
    {
    	if(GetEntryNum() >= nSize)
    	{
    		return false;
    	}
    	
    	pBuffer[nPushPos] = entry;
    	
    	nPushPos++;
    	if (nPushPos == nSize + 1)
    	{
    		nPushPos = 0;
    	}
    	nPush++;
    
    	return true;
    }

    bool Pop(QEntry & entry)
    {
        if(GetEntryNum() <= 0)
	    {
		    return false;
	    }
	    
	    entry = pBuffer[nPopPos];
	    
	    nPopPos++;
	    if (nPopPos == nSize + 1)
	    {
	    	nPopPos=0;
	    }
	    nPop++;
	
        return true;
    }

    unsigned int GetSize()const
    {
        return nSize;
    }

    unsigned int GetEntryNum()const
    {
    	return (nPush - nPop);
    }
};

#endif /* QUEUE_MT_H */
